unit ExemploEAD;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Button3: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ChavePrivada: String;
  ChavePublica: String;
  NomeArq: String;
  iRetorno: Integer;
  EAD: String;


implementation

function genkkey(ChavePublica: String; ChavePrivada: String): integer; stdcall; external 'sign_bema.dll';
function setLibType(Tipo: integer): integer; stdcall; external 'sign_bema.dll';
function generateEAD(NomeArq: String; ChavePublica: String; ChavePrivada: String; EAD:String; Sign: Integer): integer; stdcall; external 'sign_bema.dll';
function validateFile(NomeArq: String; ChavePublica: String; ChavePrivada: String): integer; stdcall; external 'sign_bema.dll';

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin

      setlength(EAD,256);
      NomeArq := Edit1.Text;
      iRetorno := generateEAD(NomeArq, ChavePublica, ChavePrivada, EAD, 1);
      if (iRetorno = 0) then
      begin
       application.MessageBox('Erro de execuo do comando!','ERRO',MB_ICONINFORMATION + MB_OK );
      end
      else
      begin
       application.MessageBox('Assinatura gerada com sucesso!','ERRO',MB_ICONINFORMATION + MB_OK );
      end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  OpenDialog1.Execute;
  Edit1.Text := OpenDialog1.FileName;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
      setlength(ChavePublica,256);
      setlength(ChavePrivada,256);

      iRetorno := genkkey(ChavePublica, ChavePrivada);
      if (iRetorno = 0) then
      begin
       application.MessageBox('Erro de execuo do comando!','ERRO',MB_ICONINFORMATION + MB_OK );
      end;

      Memo1.Text := ChavePublica;
      Memo2.Text := ChavePrivada;

end;

procedure TForm1.Button4Click(Sender: TObject);
begin

      iRetorno := validateFile(NomeArq, ChavePublica, ChavePrivada);
      if (iRetorno = 0) then
      begin
       application.MessageBox('Erro na chave !','ERRO',MB_ICONINFORMATION + MB_OK );
      end
      else
      begin
       application.MessageBox('Assinatura validada com sucesso!','ERRO',MB_ICONINFORMATION + MB_OK );
      end;
end;

end.
